package xstring

import (
	"strings"
)

func CamelToUnderscore(s string) string {
	var builder strings.Builder
	for i, c := range s {
		if i > 0 && c >= 'A' && c <= 'Z' {
			builder.WriteByte('_')
		}
		builder.WriteRune(c)
	}
	return strings.ToLower(builder.String())
}

func UnderscoreToCamel(s string, isUpperFirst bool) string {
	var builder strings.Builder
	words := strings.Split(s, "_")

	for i, word := range words {
		if word == "" {
			continue
		}
		// 处理首单词首字母
		if i == 0 && !isUpperFirst {
			builder.WriteString(strings.ToLower(word[:1]))
		} else {
			builder.WriteString(strings.ToUpper(word[:1]))
		}
		// 剩余字符处理
		if len(word) > 1 {
			builder.WriteString(strings.ToLower(word[1:]))
		}
	}
	return builder.String()
}
